/* Versión electrónica ampliada de los ejemplos para SuperCollider asociados al Libro "Composición algorítmica: Matemáticas y ciencias de la computación en la creación musical" del Dr. Jorge Variego, realizados por su autor con contribuciones de Paul Koonce, Paul Berg, Julian Peterson y del SuperCollider book de Nick Collins.
Un precedente de la idea de uso de las reflexiones iniciales de un recinto para la generación de estructuras temporales (Capítulo 8) se encuentra en el trabajo de Pablo Cetta titulado "Un modelo para la simulación del espacio en Música", Editorial Educa, Buenos Aires, 2010. */

// 2-state,  1D cellular automata.

~ca = ();
~ca.randseeds = [6,964,115,164];
thisThread.randSeed = Date.seed;
thisThread.randSeed = ~ca.randseeds.choose;
~ca.cells = Array.fill(64,{[0,1].choose});
~ca.carules = Dictionary.new;

(3**3).do({
	arg idx;
	~ca.carules.put(idx,[0,1].choose);
});

~ca.getcellval = {
	arg self, incells;
	var result;
	result = 0;
	if(incells[0]>0,{ result = result | (1<<0);});
	if(incells[1]>0,{ result = result | (1<<1);});
	if(incells[2]>0,{ result = result | (1<<2);});

	result = ~ca.carules[result];
	result;
};

~ca.tickWrap = {
	var resultArray, incellset;
	resultArray = Array.new(~ca.cells.size);

	(~ca.cells.size).do({
		arg idx;
		var leftidx, centeridx, rightidx;

		leftidx = (idx-1)%~ca.cells.size;
		centeridx = idx;
		rightidx = (idx+1)%~ca.cells.size;

		incellset = Array.new(3);
		incellset.add(~ca.cells[leftidx]);
		incellset.add(~ca.cells[centeridx]);
		incellset.add(~ca.cells[rightidx]);

		resultArray.add(~ca.getcellval(incellset));
	});

	~ca.cells = resultArray;
};

Task.new({
	loop({
		~ca.cells.do({
			arg cellval;
			[" ", "*"].at(cellval).post;
		});
		"".postln;
		~ca.tickWrap();
		0.1.wait;
	});
}).play;



