/* Versión electrónica ampliada de los ejemplos para SuperCollider asociados al Libro "Composición algorítmica: Matemáticas y ciencias de la computación en la creación musical" del Dr. Jorge Variego, realizados por su autor con contribuciones de Paul Koonce, Paul Berg, Julian Peterson y del SuperCollider book de Nick Collins.
Un precedente de la idea de uso de las reflexiones iniciales de un recinto para la generación de estructuras temporales (Capítulo 8) se encuentra en el trabajo de Pablo Cetta titulado "Un modelo para la simulación del espacio en Música", Editorial Educa, Buenos Aires, 2010. */

(
//EJEMPLO DE SINTESIS ADITIVA CON UN ESPECTRO QUE EVOLUCIONA CONFORME AL ALGORITMO ANTERIOR
// INSTRUMENTO
SynthDef.new(\genetico, { arg partials = #[1,2,3,4], out;
	var sonido;
	sonido = SinOsc.ar(partials, 0, 0.1); // GENERAMOS UN SONIDO CUYOS COMPONENTES CONTROLAMOS CON LA RUTINA
	Out.ar(out, sonido!2);

};).add;
)

(
r = Routine({

var patronVivo, patronReferencia;

// FUNCION DE APTITUD CON LA CUAL SE COMPARAN LAS MUTACIONES DEL PATRON INICIAL

	patronReferencia = Array.fill(4, {100 * (rand(10) + 1)}); // CUATRO ELEMENTOS ALEATORIOS  (0 Y 1)
("Patron de Referencia ------> " ++ patronReferencia).postln;

	x = Synth(\genetico, [\partials, patronReferencia]); // UNA SOLA INSTANCIA DEL SynthDef QUE MODIFICAMOS LUEGO CON EL x.set

while ({patronReferencia!=patronVivo},{

// MUTACIONES Y ELIMINACIONES SEGUN REGLAS SIMPLES.

patronVivo = Array.fill(6, {100 * (rand(10) + 1)}); // SEIS ELEMENTOS INICALES QUE EVENTUELMENTE, LUEGO DE ELIMINACIONES SERAN CUATRO. IMPRIMIMOS EN LA VENTANA DEL POST EL RESULTADO DE CADA UNO DE LOS PASOS.
patronVivo.postln;
patronVivo.removeAt(patronVivo.size -1); // ELIMINAMOS EL ULTIMO ELEMENTO
patronVivo.postln;
patronVivo = patronVivo.scramble; // INTERCAMBIO ALEATORIO DE ELEMENTOS
patronVivo.postln;
patronVivo.removeAt(patronVivo.size -1); // ELIMINAMOS EL ULTIMO ELEMENTO
patronVivo.postln;
patronVivo.put(0, 100 * (rand(10) + 1)); // SUSTITUIMOS EL PRIMERO
patronVivo.postln;
patronVivo = patronVivo.scramble; //
patronVivo.postln;
patronVivo.size.postln; // COMPROBAMOS QUE AHORA patronVivo TIENE 4 ELEMENTOS Y PUEDE COMPARARSE CON patronReferencia
0.01.wait;
		x.set(\partials, patronVivo); // ACTUALIZAMOS EL CONTENIDO ESPECTRAL
	};

);

"******************:) SE CUMPLIO LA FUNCION DE EVALUCION".postln; // patronVivo ES IGUAL A patronReferencia


};);

);

r.play;









