/* Versión electrónica ampliada de los ejemplos para SuperCollider asociados al Libro "Composición algorítmica: Matemáticas y ciencias de la computación en la creación musical" del Dr. Jorge Variego, realizados por su autor con contribuciones de Paul Koonce, Paul Berg, Julian Peterson y del SuperCollider book de Nick Collins.
Un precedente de la idea de uso de las reflexiones iniciales de un recinto para la generación de estructuras temporales (Capítulo 8) se encuentra en el trabajo de Pablo Cetta titulado "Un modelo para la simulación del espacio en Música", Editorial Educa, Buenos Aires, 2010. */

(
SynthDef(\campana,

    { arg out=0, freq=440, sustain=2, amp;
        var env, sonido, sonidoLim;
        env = EnvGen.kr(Env.linen(0.2, sustain, 0.05), doneAction:2);
		sonido = SinOsc.ar(freq, 0)!2;
		sonidoLim = Limiter.ar(sonido, 0.5);
        Out.ar(out, sonidoLim * env * amp )
    }).add;
);
(

~alfabeto = [60,62,64,65,67,69,71,72];

b = [[60, 64, 67], // Diccionario de triadas en Do mayor dentro de una octava
	[64, 67, 72],
	[62, 65, 69],
	[64, 67, 71],
	[65, 69, 72],
	[62, 67, 71],
	[60, 64, 69],
	[64, 69, 72],
	[71, 62, 65]

];

~funciones = [[[60, 64, 67],
	[64, 67, 72],
	[64, 67, 71],
	[60, 64, 69],
	[64, 69, 72]
	],

	[[62, 65, 69],
	[65, 69, 72]],

	[[62, 67, 71],
	[71, 62, 65]]

];

Routine({

var tonica, subdominante, dominante;
tonica = ~funciones[0];
subdominante = ~funciones[1];
dominante = ~funciones[2];
~progresion = Pseq([tonica.choose, subdominante.choose, dominante.choose], inf).asStream;

inf.do{

		a = Array.fill(3, {~alfabeto.choose}); // Genera un conjunto de 3 alturas seleccionadas de ~alfabeto
		a.postln;
		//b.postln; // Es un diccionario que contiene todas las formaciones de triadas posibles en Do mayor empleando las notas de ~alfabeto (algunas estan invertidas)

(b.size-1).do({ |i|

			if (a.includesAll(b[i]) == true, // Evaluamos si el conjunto de 3 notas a esta incluido en b.

				{ if (a.includesAll(tonica[i]) == true,

					{"Este grupo es TONICA en Do mayor".postln;

					};

					{ if (a.includesAll(subdominante[i]) == true,


						{"Este grupo es SUBDOMINANTE en Do mayor".postln;

					};












				)})},

	//{"Este grupo no es una triada en Do mayor".postln};

);

};);

	0.2.wait; // Tiempo de espera entre la generaci�n de grupos de tres notas.

};

};).play;

)
