/* Versión electrónica ampliada de los ejemplos para SuperCollider asociados al Libro "Composición algorítmica: Matemáticas y ciencias de la computación en la creación musical" del Dr. Jorge Variego, realizados por su autor con contribuciones de Paul Koonce, Paul Berg, Julian Peterson y del SuperCollider book de Nick Collins.
Un precedente de la idea de uso de las reflexiones iniciales de un recinto para la generación de estructuras temporales (Capítulo 8) se encuentra en el trabajo de Pablo Cetta titulado "Un modelo para la simulación del espacio en Música", Editorial Educa, Buenos Aires, 2010. */

(

// MARKOV DE ORDEN CERO
// LA ELECCION SE HACE SIN TENER EN CUENTA NINGUN VALOR ANTERIOR

var markovValue ;

markovValue = Routine.new({

	var transitionWeights, states, outVal ;

	// TRANSICIONES QUE FAVORECEN EXCLUSIVAMENTE EL \1;
	transitionWeights = [ 1, 0, 0, 0].normalizeSum;

	// TRANSICIONES QUE FAVORECEN A TODOS LOS ESTADOS POR IGUAL;
	// transitionWeights = [ 1, 1, 1, 1].normalizeSum;

	states = [ \1, \2,\3,\4 ] ;

	while( {true},{

		outVal = states.wchoose( transitionWeights ); // SELECCIONA UNO DE LOS ESTADOS SEGUN LAS PROBABILIDADES DE LA COLECCION transitionWeights (CON EL METODO wchoose).
		outVal.yield ;

	});

});


10.do({ markovValue.next.postln ; }) ;


)