/* Versión electrónica ampliada de los ejemplos para SuperCollider asociados al Libro "Composición algorítmica: Matemáticas y ciencias de la computación en la creación musical" del Dr. Jorge Variego, realizados por su autor con contribuciones de Paul Koonce, Paul Berg, Julian Peterson y del SuperCollider book de Nick Collins.
Un precedente de la idea de uso de las reflexiones iniciales de un recinto para la generación de estructuras temporales (Capítulo 8) se encuentra en el trabajo de Pablo Cetta titulado "Un modelo para la simulación del espacio en Música", Editorial Educa, Buenos Aires, 2010. */

(

// CADENA DE MARKOV DEL PRIMER ORDEN
// LA ELECCION DEL VALOR "QUE SIGUE" TENIENDO EN CUENTO EL ULTIMO VALOR ARROJADO

var markovValue ;

markovValue = Routine.new({

	var transitionWeights, states, outVal = \4, lastVal ;

	// PROBABILIDADES DE TRANSICION FAVORECEN EXCLUSIVAMENTE UNA LECTURA HACIA "ADELANTE" (O UNA REPETICION)
	// EN EL EJEMPLO SE UTILIZAN TRANSICIONES ENTRE LOS NUMEROS 1 A 4 ;

	transitionWeights = Dictionary[

		//    ESTE DICCIONARIO MUESTRA CLARAMENTE LAS POSIBLES TRANSICIONES. DESDE 1 EL MODELO SOLO PODRA OPTAR ENTRE 1, 2 O 3, PERO NUNCA 4; DESDE 2 PODRA OPTAR ENTRE 2, 3 O 4 PERO NUNCA 1, ETC.

		//     \1 \2 \3 \4
		\1 -> [ 1, 1, 1, 0 ], // \1 -> [ 1, 0, 0, 0 ], SI TUVIERAMOS ESTOS VALORES EL MODELO SIEMPRE REPETIRIA 1 1 1 1 ...
		\2 -> [ 0, 1, 1, 1 ],
		\3 -> [ 0, 0, 1, 1 ],
		\4 -> [ 1, 0, 0, 0 ]
	];

	states = [ \1, \2, \3, \4 ] ;

	loop{
			lastVal = outVal ; // EL ULTIMO VALOR ARROJADO ES EL QUE SE TIENE EN CUENTA PARA DETERMINAR EL SIGUIENTE
			outVal = states.wchoose( transitionWeights.at( lastVal ).normalizeSum ); // PONDERA LA TRANSICION SEGUN LAS TRANSICIONES DETERMINADAS EN EL DICCIONARIO.
			outVal.asString.yield ;
	};

});

100.do({
	v = markovValue.next ; // EL SIGUIENTE VALOR DE LA RUTINA COMO NUMERO ENTERO (NO SIMBOLO)
	(v.asInteger*2).do({ " ".post}); v.postln ;
}) ;

)