/* Versión electrónica ampliada de los ejemplos para SuperCollider asociados al Libro "Composición algorítmica: Matemáticas y ciencias de la computación en la creación musical" del Dr. Jorge Variego, realizados por su autor con contribuciones de Paul Koonce, Paul Berg, Julian Peterson y del SuperCollider book de Nick Collins.
Un precedente de la idea de uso de las reflexiones iniciales de un recinto para la generación de estructuras temporales (Capítulo 8) se encuentra en el trabajo de Pablo Cetta titulado "Un modelo para la simulación del espacio en Música", Editorial Educa, Buenos Aires, 2010. */

(

// CADENA DE MARKOV DEL SEGUNDO ORDEN
// LA ELECCION SE BASA EN LOS 2 ULTIMOS VALORES
// ESTE EEMPLO UTILIZA DICCIONARIOS "ANIDADOS"

var markovValue ;

markovValue = Routine.new({

	var transitionWeights, states, outVal = \4, lastValue = \4, secondToLastValue = \4 ;

	// DICCIONARIO DE DICCIONARIOS

	transitionWeights = Dictionary[

		\1 -> Dictionary[
				\1 -> [ 1, 0, 0, 0 ].normalizeSum, // LA SUMA NORMALIZADA ENTRE 0 Y 1
				\2 -> [ 0, 1, 0, 0 ].normalizeSum,
				\3 -> [ 0, 0, 1, 0 ].normalizeSum,
				\4 -> [ 0, 0, 0, 1 ].normalizeSum
		],
		\2 -> Dictionary[
				\1 -> [ 0, 1, 0, 0 ].normalizeSum,
				\2 -> [ 0, 0, 1, 0 ].normalizeSum,
				\3 -> [ 0, 0, 0, 1 ].normalizeSum,
				\4 -> [ 1, 0, 0, 0 ].normalizeSum
		],
		\3 -> Dictionary[
				\1 -> [ 0, 0, 1, 0 ].normalizeSum,
				\2 -> [ 0, 0, 0, 1 ].normalizeSum,
				\3 -> [ 1, 0, 0, 0 ].normalizeSum,
				\4 -> [ 0, 1, 0, 0 ].normalizeSum
		],
		\4 -> Dictionary[
				\1 -> [ 0, 0, 0, 1 ].normalizeSum,
				\2 -> [ 1, 0, 0, 0 ].normalizeSum,
				\3 -> [ 0, 1, 0, 0 ].normalizeSum,
				\4 -> [ 1, 0, 1, 0 ].normalizeSum
		]
	];

	states = [ \1,\2,\3,\4 ] ;

	loop{

			secondToLastValue = lastValue ;
			lastValue = outVal ;
			outVal = states.wchoose( transitionWeights.at( secondToLastValue ).at( lastValue ) );
			outVal.yield ;

	};

});

100.do({

	v = markovValue.next ;
	(v.asInteger*2).do({ " ".post}); v.postln ;

}) ;


)