/* Versión electrónica ampliada de los ejemplos para SuperCollider asociados al Libro "Composición algorítmica: Matemáticas y ciencias de la computación en la creación musical" del Dr. Jorge Variego, realizados por su autor con contribuciones de Paul Koonce, Paul Berg, Julian Peterson y del SuperCollider book de Nick Collins.
Un precedente de la idea de uso de las reflexiones iniciales de un recinto para la generación de estructuras temporales (Capítulo 8) se encuentra en el trabajo de Pablo Cetta titulado "Un modelo para la simulación del espacio en Música", Editorial Educa, Buenos Aires, 2010. */

(

// EJEMPLO DE SINTESIS ADITIVA INCORPORANDO UN MODELO DE MARKOV DEL PRIMER ORDEN
// AQUI LAS PROBABILIDADES DE TRANSICION SON APLICADAS PARA GENERAR UN SONIDO CUYAS FRECUENCIAS ESTAN BASADAS EN UN MODELO MARKOVIANO

SynthDef.new(\markovian,{

arg out;
var sonido, markovValue, partials;

markovValue = Routine.new({

	var transitionWeights, states, outVal = \4, lastVal ;

	transitionWeights = Dictionary[

		\1 -> [ 1, 1, 1, 0 ],
		\2 -> [ 0, 1, 1, 1 ],
		\3 -> [ 0, 1, 1, 1 ],
		\4 -> [ 1, 0, 0, 1 ]
		// \4 -> [ 1, 0, 0, 0 ] QUE PASA EN ESTE CASO? COMO "SUENA" EL MODELO DE MARKOV?
	];

	states = [ \1, \2, \3, \4 ] ;

	loop{
			lastVal = outVal ;
			outVal = states.wchoose( transitionWeights.at( lastVal ).normalizeSum );
			outVal.asString.yield ;
	};

});

	partials = Array.fill(16, {(markovValue.next.asInteger * 100) + rand2(10)}); // AQUI GENERAMOS UNA COLECCION DE 16 VALORES BASADA LA ACDENA DEL PRIMER ORDEN. CADA UNO DE LOS VALORES TIENE AGREGADO UN VALOR ALEATORIO DE ENTRE + o - 10 Hz

	partials.asInteger.postln; // LA IMPRIMIMOS EN EL POST WINDOW

	sonido = SinOsc.ar(partials.asInteger, 0, 0.05); // GENERAMOS UN SONIDO SUMANDO TODAS LAS ONDAS GENERADAS

	// sonido = SinOscFB.ar(partials.asInteger , MouseX.kr(0,4)*0.2, 0.05); // CON FEEDBACK CONTROLADO CON EL MOUSE!

	Out.ar(out, sonido!2);

};).add;

)

Synth(\markovian);

