/* Versión electrónica ampliada de los ejemplos para SuperCollider asociados al Libro "Composición algorítmica: Matemáticas y ciencias de la computación en la creación musical" del Dr. Jorge Variego, realizados por su autor con contribuciones de Paul Koonce, Paul Berg, Julian Peterson y del SuperCollider book de Nick Collins.
Un precedente de la idea de uso de las reflexiones iniciales de un recinto para la generación de estructuras temporales (Capítulo 8) se encuentra en el trabajo de Pablo Cetta titulado "Un modelo para la simulación del espacio en Música", Editorial Educa, Buenos Aires, 2010. */

// Simple control de densidades en la misma unidad temporal. Ejemplo que parte del manejo del tiempo utilizado por M. Feldman en su obra " In search for an orchestration".

(
SynthDef(\dust, { arg out=0, densidad=10;
    Out.ar(out,
        Dust.ar(densidad, 0.5)!2
    )
}).add;
)


(
Routine({

	x = Synth(\dust);

	inf.do{

		x.set(\densidad, rand(20));
		1.wait;

	};

};).play;

)

