/* Versión electrónica ampliada de los ejemplos para SuperCollider asociados al Libro "Composición algorítmica: Matemáticas y ciencias de la computación en la creación musical" del Dr. Jorge Variego, realizados por su autor con contribuciones de Paul Koonce, Paul Berg, Julian Peterson y del SuperCollider book de Nick Collins.
Un precedente de la idea de uso de las reflexiones iniciales de un recinto para la generación de estructuras temporales (Capítulo 8) se encuentra en el trabajo de Pablo Cetta titulado "Un modelo para la simulación del espacio en Música", Editorial Educa, Buenos Aires, 2010. */

// Aplicación simple de la serie dodecafónica del concierto para violín de Alban Berg

(
SynthDef(\campana,

    { arg out=0, freq=440, sustain=2;
        var env;
        env = EnvGen.kr(Env.perc(0.01, sustain, 0.5), doneAction:2);
        Out.ar(out, SinOsc.ar(freq, 0, env)!2)
    }).add;
)


(
 ~berg = Pseq([0, 3, 7, 11, 2, 5, 9, 1, 4, 6, 8, 10], inf).asStream; // Serie transpuesta a 0

r = Routine({

inf.do({

		rrand(2, 7).do({

			Synth(\campana, [\freq, ((~berg.next) + [60, 72, 48].choose).midicps, \amp, rrand(0.1, 0.15);]); // Esta rutina genera grupos (acordes) de 2 a 7 notas tomatos de la serie

		});

	3.wait;

	});

};);

p = Routine({

	inf.do({

		Synth(\campana, [\freq, ((~berg.next) + [60, 72, 48].choose).midicps, \amp, rrand(0.1, 0.2), \sustain, rrand(3.0, 4.5) ;]); // Esta rutina tiene es más activa rítmicamente, pero su contenido melódico surge de la serie ~berg

		0.2.wait;

	};);

};);

Routine ({

	r.play;
	p.play;

}).play;

)
