/* Versión electrónica ampliada de los ejemplos para SuperCollider asociados al Libro "Composición algorítmica: Matemáticas y ciencias de la computación en la creación musical" del Dr. Jorge Variego, realizados por su autor con contribuciones de Paul Koonce, Paul Berg, Julian Peterson y del SuperCollider book de Nick Collins.
Un precedente de la idea de uso de las reflexiones iniciales de un recinto para la generación de estructuras temporales (Capítulo 8) se encuentra en el trabajo de Pablo Cetta titulado "Un modelo para la simulación del espacio en Música", Editorial Educa, Buenos Aires, 2010. */

//// Basado en el juego de dados musicales de Mozart

(
SynthDef(\campana,

    { arg out=0, freq=440, sustain=1;
        var env;
        env = EnvGen.kr(Env.perc(0.01, sustain, 0.2), doneAction:2);
        Out.ar(out, SinOsc.ar(freq, 0, env)!2)
    }).add;
)

(

var dados, compases, secuencia, acordeAhora, acordeQueSigue;

compases = Dictionary[ // Material tomado de los 10 primero compases de la Sonata para piano en Si bemol mayor N333 de Mozart

	\2 -> [60, 63, 67, 63, 60, 63, 67],
	\3 -> [58, 62, 65, 62, 58, 62, 67],
	\4 -> [67, 65, 64, 62, 60, 58, 58, 62, 67, 62],
	\5 -> [53, 60, 63, 60, 53, 60, 63],
	\6 -> [63, 67, 62, 65, 63, 67, 60, 63],
	\7 -> [70, 72, 70, 69, 70, 72, 74, 75, 76, 77, 76, 77, 79, 77, 75, 74],
	\8 -> [67, 65, 63, 62, 60, 58, 58],
	\9 -> [70, 72, 74, 75, 77, 79, 81, 82, 84, 86, 87, 89, 89],
	\10 -> [57, 58, 51, 53, 57, 58, 51, 53],
	\11-> [77, 79, 77, 75, 74, 72, 70, 69],
	\12 -> [58, 62, 65, 62, 58, 62, 65]

];

Routine({

	var espera;

inf.do{

dados = Array.fill(11, {[2,3,4,5,6,7,8,9,10, 11,12].wchoose([1/36, 2/36, 3/36, 4/36, 5/36, 6/36, 5/36, 4/36, 3/36, 2/36, 1/36]);
};);

		("Nueva Secuencia Dados -->> " ++ dados ).postln;


secuencia = Pseq(dados, inf).asStream;

dados.size.do{ |i|

	acordeAhora = compases[secuencia.next.asSymbol];
	acordeQueSigue = secuencia.next;

		if (acordeQueSigue == 2, //

			// Si la expresion es verdadera

			{acordeAhora.size.do{ |i|

			Synth(\campana, [\freq, acordeAhora[i].midicps, \amp, rrand(0.3, 0.6), \sustain, rrand(0.1, 2.0)]);
			acordeAhora[i].postln;
					0.2.wait;

				};},

			// Si la expresion es falsa

			{
				espera = [0, 0.1].choose;

						acordeAhora.size.do{ |i|

							Synth(\campana, [\freq, acordeAhora[i].midicps, \amp, rrand(0.3, 0.6), \sustain, rrand(0.1, 2.0)]);
							acordeAhora[i].postln;
							espera.wait;

			};}

		);

		0.5.wait;

		"**********************************".postln;
	};

	};

};).play;

);

