/* Versión electrónica ampliada de los ejemplos para SuperCollider asociados al Libro "Composición algorítmica: Matemáticas y ciencias de la computación en la creación musical" del Dr. Jorge Variego, realizados por su autor con contribuciones de Paul Koonce, Paul Berg, Julian Peterson y del SuperCollider book de Nick Collins.
Un precedente de la idea de uso de las reflexiones iniciales de un recinto para la generación de estructuras temporales (Capítulo 8) se encuentra en el trabajo de Pablo Cetta titulado "Un modelo para la simulación del espacio en Música", Editorial Educa, Buenos Aires, 2010. */

(

SynthDef(\ring,
	{
	arg freq=440, densidad=3, decayTime=2, out=0;
	var sound;
	sound =  Ringz.ar(Dust.ar(densidad, 0.3), freq, decayTime);
	Out.ar(out, sound);
}).add;

)

(

a = Synth(\ring);
p = Pseq([60, 62, 64, 65, 67, 69, 71], inf).asStream; // Las alturas de este instrumento están determinadas por la secuencia p.
b = Synth(\ring, [\out, 1]);
q = Prand([61, 63, 66, 68, 70, 72], inf).asStream; // Las alturas de este instrumento son seleccionadas en forma aleatoria de q. El resultante armónico es un agregado de 12 alturas.

r = Routine({

	inf.do{

a.set(\freq, p.midicps.next, \decayTime, {rrand(0.1, 3)}, \densidad, 3);
		rrand(0.1, 0.5).wait;
	};
};);

y = Routine({

	inf.do{

		b.set(\freq, q.midicps.next, \decayTime, {rrand(0.1, 3)}, \densidad, rrand(2, 30));
		rrand(0.1, 0.3).wait;
	};

};);

Routine({

	r.play; // Los dos instrumentos "tocan" en forma simultánea con movimientos rítmicos independientes sugiriendo un contrapunto aleatorio alla Lutoslawsky.
	y.play;

};).play;

)

