/* Versión electrónica ampliada de los ejemplos para SuperCollider asociados al Libro "Composición algorítmica: Matemáticas y ciencias de la computación en la creación musical" del Dr. Jorge Variego, realizados por su autor con contribuciones de Paul Koonce, Paul Berg, Julian Peterson y del SuperCollider book de Nick Collins.
Un precedente de la idea de uso de las reflexiones iniciales de un recinto para la generación de estructuras temporales (Capítulo 8) se encuentra en el trabajo de Pablo Cetta titulado "Un modelo para la simulación del espacio en Música", Editorial Educa, Buenos Aires, 2010. */

(


SynthDef(\sinu, {|freq = 440 out=0|
	Out.ar(out, SinOsc.ar(freq, 0, 0.2)) }).add;

)
(
var cantus = [60, 62, 64, 62, 65, 67, 64, 62, 60], cantusAhora;

var contrapunto = [[72], [71, 69, 65], [72, 71, 67], [71, 69, 65], [72, 69], [71], [72, 71, 67], [71], [72]], contrapuntoAhora, cantusDespues, contrapuntoDespues, intervalo, intervaloDespues, quintasParalelas = [1];

while({quintasParalelas.includes(1) == true}, // Crear un contrapunto nuevo hasta que NO haya quintas paralelas

	{
	contrapuntoAhora = Array.fill(cantus.size, {|i| (contrapunto[i].choose);});
	cantus.postln;
	contrapuntoAhora.postln;
	intervalo = Array.fill(cantus.size, {|i| (contrapuntoAhora[i] - cantus[i]);});
	intervalo.postln;

    quintasParalelas = Array.fill((cantus.size - 1), {|i| if(intervalo[i]==intervalo[i+1] && intervalo[i]==7, {1}, {0});};); // Crea una lista de binaria, donde 1 indica la existancia de 5tas paralelas
		quintasParalelas.insert(0, 0).postln;};
);

r = Routine({

	c = Synth(\sinu);
	d = Synth(\sinu, [\out, 1]);

	("Contrapunto SIN 5tas paralelas: " ++ contrapuntoAhora).postln;

cantus.size.do{|i| // Rutina que simplemente transita las alturas de las dos melodías generadas y corregidas

		cantusAhora = cantus[i];
		c.set(\freq, cantusAhora.midicps);
		d.set(\freq, contrapuntoAhora[i].midicps);

		("Nota cantus: " ++ cantusAhora ++ " Nota contrapunto: " ++ contrapuntoAhora[i]).postln;

		2.wait;

};

};)

)

r.play;



