/* Versión electrónica ampliada de los ejemplos para SuperCollider asociados al Libro "Composición algorítmica: Matemáticas y ciencias de la computación en la creación musical" del Dr. Jorge Variego, realizados por su autor con contribuciones de Paul Koonce, Paul Berg, Julian Peterson y del SuperCollider book de Nick Collins.
Un precedente de la idea de uso de las reflexiones iniciales de un recinto para la generación de estructuras temporales (Capítulo 8) se encuentra en el trabajo de Pablo Cetta titulado "Un modelo para la simulación del espacio en Música", Editorial Educa, Buenos Aires, 2010. */

(

// Instrumento basado en una formante "ah"
SynthDef(\formante,{ arg out=0, freq=220, gate=1;
	var sound, soundMixed;
	a = [ 730, 1090, 2440 ]; //Array.fill(20, {rrand(200, 3456);})
	sound = Formant.ar(freq, a , 0.001, 0.125) ;
	soundMixed = Mix.new(sound);
	Out.ar(out, soundMixed * gate);

};).add;

)

(
var cantus = [60, 62, 64, 62, 65, 67, 64, 62, 60], cantusAhora;

var contrapunto = [[72], [71, 69, 65], [72, 71, 67], [71, 69, 65], [72, 69], [71], [72, 71, 67], [71], [72]], contrapuntoAhora, cantusDespues, contrapuntoDespues, intervalo, intervaloDespues, quintasParalelas = [1]; // Colección bidimensional que contiene todas las posibles soluciones de un contrapunto de la primera especie para el cantus dado. No todas las soluciones son correctas.

while({quintasParalelas.includes(1) == true}, // Crear un contrapunto nuevo hasta que NO haya quintas paralelas.

	{
	contrapuntoAhora = Array.fill(cantus.size, {|i| (contrapunto[i].choose);});
	cantus.postln;
	contrapuntoAhora.postln;
	intervalo = Array.fill(cantus.size, {|i| (contrapuntoAhora[i] - cantus[i]);});
	intervalo.postln;

    quintasParalelas = Array.fill((cantus.size - 1), {|i| if(intervalo[i]==intervalo[i+1] && intervalo[i]==7, {1}, {0});};); // Crea una lista de binaria, donde 1 indica la existancia de 5tas paralelas
		quintasParalelas.insert(0, 0).postln;};
);

r = Routine({

	c = Synth(\formante);
	d = Synth(\formante, [\out, 1]);

	("Contrapunto SIN 5tas paralelas: " ++ contrapuntoAhora).postln;

cantus.size.do{|i| // Rutina que simplemente transita las alturas de las dos melodías generadas y corregidas

		cantusAhora = cantus[i];
		c.set(\freq, cantusAhora.midicps);
		d.set(\freq, contrapuntoAhora[i].midicps);

		("Nota cantus: " ++ cantusAhora ++ " Nota contrapunto: " ++ contrapuntoAhora[i]).postln;

		2.wait;

};

	4.wait;

	"6 segundos en la octava final *********************".postln;

	    c.set(\gate, 0);
		d.set(\gate, 0);

};)

)

r.play;





