/* Versión electrónica ampliada de los ejemplos para SuperCollider asociados al Libro "Composición algorítmica: Matemáticas y ciencias de la computación en la creación musical" del Dr. Jorge Variego, realizados por su autor con contribuciones de Paul Koonce, Paul Berg, Julian Peterson y del SuperCollider book de Nick Collins.
Un precedente de la idea de uso de las reflexiones iniciales de un recinto para la generación de estructuras temporales (Capítulo 8) se encuentra en el trabajo de Pablo Cetta titulado "Un modelo para la simulación del espacio en Música", Editorial Educa, Buenos Aires, 2010. */

(

var homeDirectory="/Users/musicstaff" ;

var soundFileNames, durationOfFile, buffer, outPanned, density, density1, paneo, paneo1, escala, escala1, escala2, escala21, dynamics, diatonic, diatonic1, dynamics1, speed, ritmo2, speed1, escala3, escala31, ritmo, ritmo1, escala4, escala41, escala5, escala51, scaleOffset, yeite1, ritmo3, yeite2, yeite3, percu, alberti1, melodia1, bass, soloDb, soloRitmo, escala6, soloTempo,preparation, tempo, percu1, percu2, dynamics2, bass1, duration2, firstNote, transposition, ousSigFilt;

paneo = Pseq(#[-0.1, 0, 0.1], inf);
paneo1 = paneo.asStream;

////////////////////////////////////////////////////////////////////////////////
/////////////////////////// PIANO //////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

soundFileNames = IdentityDictionary[

	\1 -> "/Jazz-quartet/Piano/A0.wav",
	\2 -> "/Jazz-quartet/Piano/A#0.wav",
	\3 -> "/Jazz-quartet/Piano/B0.wav",
	\4 -> "/Jazz-quartet/Piano/C1.wav",
	\5 -> "/Jazz-quartet/Piano/C#1.wav",
	\6 -> "/Jazz-quartet/Piano/D1.wav",
	\7 -> "/Jazz-quartet/Piano/D#1.wav",
	\8 -> "/Jazz-quartet/Piano/E1.wav",
	\9 -> "/Jazz-quartet/Piano/F1.wav",
	\10 -> "/Jazz-quartet/Piano/F#1.wav",
	\11 -> "/Jazz-quartet/Piano/G1.wav",
	\12 -> "/Jazz-quartet/Piano/G#1.wav",
	\13 -> "/Jazz-quartet/Piano/A1.wav",
	\14 -> "/Jazz-quartet/Piano/A#1.wav",
	\15 -> "/Jazz-quartet/Piano/B1.wav",
	\16 -> "/Jazz-quartet/Piano/C2.wav",
	\17 -> "/Jazz-quartet/Piano/C#2.wav",
	\18 -> "/Jazz-quartet/Piano/D2.wav",
	\19 -> "/Jazz-quartet/Piano/D#2.wav",
	\20 -> "/Jazz-quartet/Piano/E2.wav",
	\21 -> "/Jazz-quartet/Piano/F2.wav",
	\22 -> "/Jazz-quartet/Piano/F#2.wav",
	\23 -> "/Jazz-quartet/Piano/G2.wav",
	\24 -> "/Jazz-quartet/Piano/G#2.wav",
	\25 -> "/Jazz-quartet/Piano/A2.wav",
	\26 -> "/Jazz-quartet/Piano/A#2.wav",
	\27 -> "/Jazz-quartet/Piano/B2.wav",
	\28 -> "/Jazz-quartet/Piano/C3.wav",
	\29 -> "/Jazz-quartet/Piano/C#3.wav",
	\30 -> "/Jazz-quartet/Piano/D3.wav",
	\31 -> "/Jazz-quartet/Piano/D#3.wav",
	\32 -> "/Jazz-quartet/Piano/E3.wav",
	\33 -> "/Jazz-quartet/Piano/F3.wav",
	\34 -> "/Jazz-quartet/Piano/F#3.wav",
	\35 -> "/Jazz-quartet/Piano/G3.wav",
	\36 -> "/Jazz-quartet/Piano/G#3.wav",
	\37 -> "/Jazz-quartet/Piano/A3.wav",
	\38 -> "/Jazz-quartet/Piano/A#3.wav",
	\39 -> "/Jazz-quartet/Piano/B3.wav",
	\40 -> "/Jazz-quartet/Piano/C4.wav",
	\41 -> "/Jazz-quartet/Piano/C#4.wav",
	\42 -> "/Jazz-quartet/Piano/D4.wav",
	\43 -> "/Jazz-quartet/Piano/D#4.wav",
	\44 -> "/Jazz-quartet/Piano/E4.wav",
	\45 -> "/Jazz-quartet/Piano/F4.wav",
	\46 -> "/Jazz-quartet/Piano/F#4.wav",
	\47 -> "/Jazz-quartet/Piano/G4.wav",
	\48 -> "/Jazz-quartet/Piano/G#4.wav",
	\49 -> "/Jazz-quartet/Piano/A4.wav",
	\50 -> "/Jazz-quartet/Piano/A#4.wav",
	\51 -> "/Jazz-quartet/Piano/B4.wav",
	\52 -> "/Jazz-quartet/Piano/C5.wav",
	\53 -> "/Jazz-quartet/Piano/C#5.wav",
	\54 -> "/Jazz-quartet/Piano/D5.wav",
	\55 -> "/Jazz-quartet/Piano/D#5.wav",
	\56 -> "/Jazz-quartet/Piano/E5.wav",
	\57 -> "/Jazz-quartet/Piano/F5.wav",
	\58 -> "/Jazz-quartet/Piano/F#5.wav",
	\59 -> "/Jazz-quartet/Piano/G5.wav",
	\60 -> "/Jazz-quartet/Piano/G#5.wav",
	\61 -> "/Jazz-quartet/Piano/A5.wav",
	\62 -> "/Jazz-quartet/Piano/A#5.wav",
	\63 -> "/Jazz-quartet/Piano/B5.wav",
	\64 -> "/Jazz-quartet/Piano/C6.wav",
	\65 -> "/Jazz-quartet/Piano/C#6.wav",
	\66 -> "/Jazz-quartet/Piano/D6.wav",
	\67 -> "/Jazz-quartet/Piano/D#6.wav",
	\68 -> "/Jazz-quartet/Piano/E6.wav",
	\69 -> "/Jazz-quartet/Piano/F6.wav",
	\70 -> "/Jazz-quartet/Piano/F#6.wav",
	\71 -> "/Jazz-quartet/Piano/G6.wav",
	\72 -> "/Jazz-quartet/Piano/G#6.wav",
	\73 -> "/Jazz-quartet/Piano/A6.wav",
	\74 -> "/Jazz-quartet/Piano/A#6.wav",
	\75 -> "/Jazz-quartet/Piano/B6.wav",
	\76 -> "/Jazz-quartet/Piano/C7.wav",
	\77 -> "/Jazz-quartet/Piano/C#7.wav",
	\78 -> "/Jazz-quartet/Piano/D7.wav",
	\79 -> "/Jazz-quartet/Piano/D#7.wav",
	\80 -> "/Jazz-quartet/Piano/E7.wav",
	\81 -> "/Jazz-quartet/Piano/F7.wav",
	\82 -> "/Jazz-quartet/Piano/F#7.wav",
	\83 -> "/Jazz-quartet/Piano/G7.wav",
	\84 -> "/Jazz-quartet/Piano/G#7.wav",
	\85 -> "/Jazz-quartet/Piano/A7.wav",
	\86 -> "/Jazz-quartet/Piano/A#7.wav",
	\87 -> "/Jazz-quartet/Piano/B7.wav",


] ;

soundFileNames.keys.do({arg key;
	soundFileNames[ key ] = homeDirectory  ++ soundFileNames[ key ] ;

});

buffer = IdentityDictionary.new( soundFileNames.size ) ;

soundFileNames.keys.do({ arg name, i;
	buffer.add(  name -> Buffer.read(s, soundFileNames.at( name ) )      ) ; });

"SOUND FILE BUFFERS: ".postln ;
buffer.postln ;

durationOfFile = IdentityDictionary.new( soundFileNames.size ) ;

soundFileNames.keys.do({ arg name, i;
	f = SoundFile.new;
	f.openRead(soundFileNames.at( name ) );
	durationOfFile.add( name -> (f.numFrames / f.sampleRate) ) ;
});

"SOUND FILE DURATIONS:".postln ;
durationOfFile.postln ;

SynthDef("piano",{ arg out=0, bufnum=0, semitoneTranspose=0.0, envTimeScale=1, db=0, pan=0.0;
	var rateChange, env, envsig, outSig, balanced, outSigFilt ;

	env  = Env.new( [ 0.0, 1.0, 1.0, 0.0 ],[ 0.001, 0.699, 0.3 ],'linear');

	rateChange = (60 + semitoneTranspose).midicps / 60.midicps ;

	envsig = EnvGen.kr( env, timeScale: envTimeScale, levelScale: db.dbamp, doneAction: 2  ) ;

	outSig = Limiter.ar((PlayBuf.ar(1,bufnum, BufRateScale.kr(bufnum) * rateChange)), 0.6, 0.01) ;

	Out.ar(out, Pan2.ar(outSig * envsig, pan));

}).load(s) ;


r = Routine.new({
					var swing, swingDuracion;

						var semitoneTranspose, duration, attackPointDuration, decibels,
	sampleFileToPlayNow, pattern, firstNoteEver, pan, sampleFileToPlayNow1, sampleFileToPlayNow2;

	var midiPitchNow, sampleMidiKeySymbol, temp,
	midiPitchOfSelectedSample, partialCf, bw , midiPitchOfSamples, repatsFirstSection,  accel, 	rall, rallAcell, chordInterval, density, pianonote, sampleFileToPlayNow3, cymbal,snare, duration1;



		1.wait;
		duration = 6;
		sampleFileToPlayNow = \40;



		swing = Pseq([rand(-5.0), 0.0], inf).asStream;

		~tempo = 0.4;
		~ritmo = ([0.5, 1, 0.25, 0.33, 0.17, 1.5, 2.5].wchoose([101, 4, 56, 9, 15, 1, 1 ].normalizeSum));

		~notaDespues = 40;
		~nota = ([-1,1,-2,2,-3,3,-4,4,-5,5,-6,6,-7,7,-8,8,-9,9,-10,10,-11,11,-12,12].wchoose([25, 24, 36, 22,20, 21,11,7,5,2,1,0,0,1,0,2,1,4,0,0,0,0,0,1].normalizeSum));

		inf.do({

			~nota.postln;

			//////////////////////////////////////////////////
			// ACA VA EL TESTEO CONDICIONAL PARA NOTADESPUES//
			//////////////////////////////////////////////////

			// SUCESIONES DE NOTAS SEGUN LAS TABLAS DE SUCESIONES

// semitono ascendente

if (~nota == 1, {~nota = ([1,-1,2,-2,3,-3,4,-4,5,-5,6,-6].wchoose([4,2,7,2,3,2,1,2,0,0,0,1].normalizeSum))},

	// semitono descendente

	{if (~nota == -1, {~nota = ([1,-1,2,-2,3,-3,4,-4,9,-9,12].wchoose([2,3,0,9,3,1,0,1,2,1,1].normalizeSum))},

		// segunda mayor ascendente

		{if (~nota == 2, {~nota = ([1,-1,2,-2,3,-3,4].wchoose([4,0,4,7,3,2,0].normalizeSum))},

			// segunda mayor descendente

			{if (~nota == -2, {~nota = ([1,-1,2,-2,3,-3,4,-4,9,-9,12].wchoose([2,3,0,9,3,1,0,1,2,1,1].normalizeSum))},

				// tercera menor ascendente

				{if (~nota == 3, {~nota = ([1,-1,2,-2,3,-3,4,-4,9].wchoose([0,1,3,3,5,5,5,0,1].normalizeSum))},

					// tercera menor descendente

					{if (~nota == -3, {~nota = ([1,-1,2,-2,3,-3,4,-4,5].wchoose([6,1,5,1,3,0,0,2,2].normalizeSum))},

						// tercera mayor ascendente

						{if (~nota == 4, {~nota = ([3,-4,7].wchoose([3,1,1].normalizeSum))},

							// tercera mayor descendente

							{if (~nota == -4, {~nota = ([1,-1,2,-2,3,-3,4,-4, 9, -9, 12].wchoose([2,3,0,9,2,1,0,1,2,1,1].normalizeSum))},

								// cuarta ascendente

								{if (~nota == 5, {~nota = ([-1, 3].wchoose([1,1].normalizeSum))},

									// cuarta descendente
									{if (~nota == -5, {~nota = ([1, 3, 9, -4 ].wchoose([1,1,1,1].normalizeSum))},

										// cuarta aumentada ascendente (NO)

											// cuarta aumentada descendente

											{if (~nota == -6, {~nota = -2 },

												// quinta ascendente

												{if (~nota == 7, {~nota = [2, -2].choose },

												// quinta descendente (NO)
												// sexta menor ascendente

												{if (~nota == 8, {~nota = [2, 1].choose },

												// sexta mayor ascendente

												{if (~nota == 9, {~nota = [-3, -5, -1].choose},

												// sexta mayor descendente

												{if (~nota == -9, {~nota = 3},
												// octava ascendente

												{if (~nota == 12, {~nota = 1},

					)}
					)}
					)}
					)}
					)}
					)}
					)}
					)}
					)}
					)}
					)}
					)}
					)}
					)}
					)}
					);


	////////////////////////////////////////////////////////////////////////////////////
	// SUCESIONES RITMICAS SEGUN LAS TABLAS DE SUCESIONES /////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////
			~amplitude = 1.0;

					if (~ritmo == 0.5, {~ritmo = ([1, 0.17, 0.33, 0.25, 0.5, 2.5].wchoose([4, 2, 3, 4, 86, 2].normalizeSum)); ~amplitude = (swing.next) * rrand(0.8, 1.0)},

							// si no es eight

							{if (~ritmo == 0.25, {~ritmo = ([1.5, 0.5, 0.25].wchoose([1.8, 9.25, 88].normalizeSum))},

								// si no es sixteenth

									{if (~ritmo == 0.33, { ~ritmo = ([0.5, 1, 0.33].wchoose([2, 1, 8].normalizeSum))},

											// si no es un tuplet

									              { if (~ritmo == 0.17, {~ritmo = ([0.5,  0.17].wchoose([25, 75].normalizeSum))}

												         , { if (~ritmo == 1, {~ritmo = 0.5},
													         			                                    {if (~ritmo == 1.5, {~ritmo = [0.25, 0.5].choose; ~amplitude = 0}, // <- Ver
													         			                                           {if (~ritmo == 2.5, {~ritmo = [0.25, 1.5].choose; ~amplitude = 0 } // <- Ver
														         			                                    )};
		         			                                    )}
												                  )}		         			                                    )}
									                             )};
							                                    )}
							);

				~ritmo.postln;
				~notaDespues = (~notaDespues + ~nota);
				if ( ~notaDespues > 80, {~notaDespues = ~notaDespues - 12},

					{if ( ~notaDespues < 10, {~notaDespues = ~notaDespues + 12},

					)}

					);

				~notaDespues.postln;
				sampleFileToPlayNow = ~notaDespues.asSymbol;

		Synth.new("piano", [\out, 0, \bufnum, buffer.at(sampleFileToPlayNow).bufnum, \duration, (~ritmo * ~tempo),
			 \envTimeScale, 3, \pan, paneo1.next, \db, ~amplitude]); // <- Paneo
			 (~ritmo * ~tempo).wait;

		});

});

b =  Routine.new({
						var acorde, fundamental, dura, compin, sampleFileToPlayNow;
	acorde = [0,4,7]; // acordes mayores :)
	dura = [2, 5];

	inf.do ({

			sampleFileToPlayNow = ~notaDespues.asSymbol; // <- ACA SIEMPRE EL ACORDE DUPLICA LA NOTA DEL SOLO

		fundamental = rrand(20, 40).asSymbol;
		compin =  dura.choose;

		Synth.new("piano", [\out, rrand(0, 2), \bufnum, buffer.at(sampleFileToPlayNow).bufnum, \duration, (~ritmo * ~tempo),
			 \envTimeScale, compin, \pan, 1, \db, ~amplitude * 0.25]);

		Synth.new("piano", [\out, rrand(3, 5), \bufnum, buffer.at(sampleFileToPlayNow).bufnum, \duration, (~ritmo * ~tempo),
			 \envTimeScale, compin, \semitoneTranspose, 3, \pan, 1, \db, ~amplitude * 0.25]);

		Synth.new("piano", [\out, rrand(6, 8), \bufnum, buffer.at(sampleFileToPlayNow).bufnum, \duration, (~ritmo * ~tempo),
			 \envTimeScale, compin, \semitoneTranspose, -5, \pan, 1, \db, ~amplitude * 0.25]);


	4.wait;

	});

});

c = Routine.new({

	r.play;

	// b.play;

}).play;


)




